/* generated by rust_qt_binding_generator */
#include "Bindings.h"

namespace {

    struct option_quintptr {
    public:
        quintptr value;
        bool some;
        operator QVariant() const {
            if (some) {
                return QVariant::fromValue(value);
            }
            return QVariant();
        }
    };
    static_assert(std::is_pod<option_quintptr>::value, "option_quintptr must be a POD type.");

    typedef void (*qstring_set)(QString* val, const char* utf8, int nbytes);
    void set_qstring(QString* val, const char* utf8, int nbytes) {
        *val = QString::fromUtf8(utf8, nbytes);
    }

    typedef void (*qbytearray_set)(QByteArray* val, const char* bytes, int nbytes);
    void set_qbytearray(QByteArray* v, const char* bytes, int nbytes) {
        if (v->isNull() && nbytes == 0) {
            *v = QByteArray(bytes, nbytes);
        } else {
            v->truncate(0);
            v->append(bytes, nbytes);
        }
    }

    struct qmodelindex_t {
        int row;
        quintptr id;
    };
    inline QVariant cleanNullQVariant(const QVariant& v) {
        return (v.isNull()) ?QVariant() :v;
    }
    inline void emailBodyChanged(Email* o)
    {
        emit o->bodyChanged();
    }
    inline void emailDateChanged(Email* o)
    {
        emit o->dateChanged();
    }
    inline void emailFromChanged(Email* o)
    {
        emit o->fromChanged();
    }
    inline void emailHtmlChanged(Email* o)
    {
        emit o->htmlChanged();
    }
    inline void emailSubjectChanged(Email* o)
    {
        emit o->subjectChanged();
    }
    inline void mailModelConfigFileChanged(MailModel* o)
    {
        emit o->configFileChanged();
    }
    inline void mailModelCurrentFolderChanged(MailModel* o)
    {
        emit o->currentFolderChanged();
    }
}
extern "C" {
    void attachments_data_bytes(const Attachments::Private*, int, QByteArray*, qbytearray_set);
    void attachments_data_name(const Attachments::Private*, int, QString*, qstring_set);
    void attachments_sort(Attachments::Private*, unsigned char column, Qt::SortOrder order = Qt::AscendingOrder);

    int attachments_row_count(const Attachments::Private*);
    bool attachments_insert_rows(Attachments::Private*, int, int);
    bool attachments_remove_rows(Attachments::Private*, int, int);
    bool attachments_can_fetch_more(const Attachments::Private*);
    void attachments_fetch_more(Attachments::Private*);
}
int Attachments::columnCount(const QModelIndex &parent) const
{
    return (parent.isValid()) ? 0 : 1;
}

bool Attachments::hasChildren(const QModelIndex &parent) const
{
    return rowCount(parent) > 0;
}

int Attachments::rowCount(const QModelIndex &parent) const
{
    return (parent.isValid()) ? 0 : attachments_row_count(m_d);
}

bool Attachments::insertRows(int row, int count, const QModelIndex &)
{
    return attachments_insert_rows(m_d, row, count);
}

bool Attachments::removeRows(int row, int count, const QModelIndex &)
{
    return attachments_remove_rows(m_d, row, count);
}

QModelIndex Attachments::index(int row, int column, const QModelIndex &parent) const
{
    if (!parent.isValid() && row >= 0 && row < rowCount(parent) && column >= 0 && column < 1) {
        return createIndex(row, column, (quintptr)row);
    }
    return QModelIndex();
}

QModelIndex Attachments::parent(const QModelIndex &) const
{
    return QModelIndex();
}

bool Attachments::canFetchMore(const QModelIndex &parent) const
{
    return (parent.isValid()) ? 0 : attachments_can_fetch_more(m_d);
}

void Attachments::fetchMore(const QModelIndex &parent)
{
    if (!parent.isValid()) {
        attachments_fetch_more(m_d);
    }
}
void Attachments::updatePersistentIndexes() {}

void Attachments::sort(int column, Qt::SortOrder order)
{
    attachments_sort(m_d, column, order);
}
Qt::ItemFlags Attachments::flags(const QModelIndex &i) const
{
    auto flags = QAbstractItemModel::flags(i);
    return flags;
}

QByteArray Attachments::bytes(int row) const
{
    QByteArray b;
    attachments_data_bytes(m_d, row, &b, set_qbytearray);
    return b;
}

QString Attachments::name(int row) const
{
    QString s;
    attachments_data_name(m_d, row, &s, set_qstring);
    return s;
}

QVariant Attachments::data(const QModelIndex &index, int role) const
{
    Q_ASSERT(rowCount(index.parent()) > index.row());
    switch (index.column()) {
    case 0:
        switch (role) {
        case Qt::UserRole + 0:
            return QVariant::fromValue(bytes(index.row()));
        case Qt::UserRole + 1:
            return QVariant::fromValue(name(index.row()));
        }
    }
    return QVariant();
}

int Attachments::role(const char* name) const {
    auto names = roleNames();
    auto i = names.constBegin();
    while (i != names.constEnd()) {
        if (i.value() == name) {
            return i.key();
        }
        ++i;
    }
    return -1;
}
QHash<int, QByteArray> Attachments::roleNames() const {
    QHash<int, QByteArray> names = QAbstractItemModel::roleNames();
    names.insert(Qt::UserRole + 0, "bytes");
    names.insert(Qt::UserRole + 1, "name");
    return names;
}
QVariant Attachments::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (orientation != Qt::Horizontal) {
        return QVariant();
    }
    return m_headerData.value(qMakePair(section, (Qt::ItemDataRole)role), role == Qt::DisplayRole ?QString::number(section + 1) :QVariant());
}

bool Attachments::setHeaderData(int section, Qt::Orientation orientation, const QVariant &value, int role)
{
    if (orientation != Qt::Horizontal) {
        return false;
    }
    m_headerData.insert(qMakePair(section, (Qt::ItemDataRole)role), value);
    return true;
}

extern "C" {
    Attachments::Private* attachments_new(Attachments*,
        void (*)(const Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*, quintptr, quintptr),
        void (*)(Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int, int),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int),
        void (*)(Attachments*));
    void attachments_free(Attachments::Private*);
    void attachments_save_to_folder(const Attachments::Private*, quint32, const ushort*, int, QString*, qstring_set);
};

extern "C" {
    Email::Private* email_new(Email*, Attachments*,
        void (*)(const Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*, quintptr, quintptr),
        void (*)(Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int, int),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int),
        void (*)(Attachments*), void (*)(Email*), void (*)(Email*), void (*)(Email*), void (*)(Email*), void (*)(Email*));
    void email_free(Email::Private*);
    Attachments::Private* email_attachments_get(const Email::Private*);
    void email_body_get(const Email::Private*, QString*, qstring_set);
    void email_date_get(const Email::Private*, QString*, qstring_set);
    void email_from_get(const Email::Private*, QString*, qstring_set);
    void email_html_get(const Email::Private*, QString*, qstring_set);
    void email_subject_get(const Email::Private*, QString*, qstring_set);
};

extern "C" {
    void folder_tree_listing_data_date(const FolderTreeListing::Private*, quintptr, QString*, qstring_set);
    void folder_tree_listing_data_from(const FolderTreeListing::Private*, quintptr, QString*, qstring_set);
    void folder_tree_listing_data_section(const FolderTreeListing::Private*, quintptr, QString*, qstring_set);
    bool folder_tree_listing_data_seen(const FolderTreeListing::Private*, quintptr);
    void folder_tree_listing_data_subject(const FolderTreeListing::Private*, quintptr, QString*, qstring_set);
    quint64 folder_tree_listing_data_uid(const FolderTreeListing::Private*, quintptr);
    void folder_tree_listing_sort(FolderTreeListing::Private*, unsigned char column, Qt::SortOrder order = Qt::AscendingOrder);

    int folder_tree_listing_row_count(const FolderTreeListing::Private*, option_quintptr);
    bool folder_tree_listing_can_fetch_more(const FolderTreeListing::Private*, option_quintptr);
    void folder_tree_listing_fetch_more(FolderTreeListing::Private*, option_quintptr);
    quintptr folder_tree_listing_index(const FolderTreeListing::Private*, option_quintptr, int);
    qmodelindex_t folder_tree_listing_parent(const FolderTreeListing::Private*, quintptr);
    int folder_tree_listing_row(const FolderTreeListing::Private*, quintptr);
    option_quintptr folder_tree_listing_check_row(const FolderTreeListing::Private*, quintptr, int);
}
int FolderTreeListing::columnCount(const QModelIndex &) const
{
    return 1;
}

bool FolderTreeListing::hasChildren(const QModelIndex &parent) const
{
    return rowCount(parent) > 0;
}

int FolderTreeListing::rowCount(const QModelIndex &parent) const
{
    if (parent.isValid() && parent.column() != 0) {
        return 0;
    }
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    return folder_tree_listing_row_count(m_d, rust_parent);
}

bool FolderTreeListing::insertRows(int, int, const QModelIndex &)
{
    return false; // not supported yet
}

bool FolderTreeListing::removeRows(int, int, const QModelIndex &)
{
    return false; // not supported yet
}

QModelIndex FolderTreeListing::index(int row, int column, const QModelIndex &parent) const
{
    if (row < 0 || column < 0 || column >= 1) {
        return QModelIndex();
    }
    if (parent.isValid() && parent.column() != 0) {
        return QModelIndex();
    }
    if (row >= rowCount(parent)) {
        return QModelIndex();
    }
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    const quintptr id = folder_tree_listing_index(m_d, rust_parent, row);
    return createIndex(row, column, id);
}

QModelIndex FolderTreeListing::parent(const QModelIndex &index) const
{
    if (!index.isValid()) {
        return QModelIndex();
    }
    const qmodelindex_t parent = folder_tree_listing_parent(m_d, index.internalId());
    return parent.row >= 0 ?createIndex(parent.row, 0, parent.id) :QModelIndex();
}

bool FolderTreeListing::canFetchMore(const QModelIndex &parent) const
{
    if (parent.isValid() && parent.column() != 0) {
        return false;
    }
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    return folder_tree_listing_can_fetch_more(m_d, rust_parent);
}

void FolderTreeListing::fetchMore(const QModelIndex &parent)
{
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    folder_tree_listing_fetch_more(m_d, rust_parent);
}
void FolderTreeListing::updatePersistentIndexes() {
    const auto from = persistentIndexList();
    auto to = from;
    auto len = to.size();
    for (int i = 0; i < len; ++i) {
        auto index = to.at(i);
        auto row = folder_tree_listing_check_row(m_d, index.internalId(), index.row());
        if (row.some) {
            to[i] = createIndex(row.value, index.column(), index.internalId());
        } else {
            to[i] = QModelIndex();
        }
    }
    changePersistentIndexList(from, to);
}

void FolderTreeListing::sort(int column, Qt::SortOrder order)
{
    folder_tree_listing_sort(m_d, column, order);
}
Qt::ItemFlags FolderTreeListing::flags(const QModelIndex &i) const
{
    auto flags = QAbstractItemModel::flags(i);
    return flags;
}

QString FolderTreeListing::date(const QModelIndex& index) const
{
    QString s;
    folder_tree_listing_data_date(m_d, index.internalId(), &s, set_qstring);
    return s;
}

QString FolderTreeListing::from(const QModelIndex& index) const
{
    QString s;
    folder_tree_listing_data_from(m_d, index.internalId(), &s, set_qstring);
    return s;
}

QString FolderTreeListing::section(const QModelIndex& index) const
{
    QString s;
    folder_tree_listing_data_section(m_d, index.internalId(), &s, set_qstring);
    return s;
}

bool FolderTreeListing::seen(const QModelIndex& index) const
{
    return folder_tree_listing_data_seen(m_d, index.internalId());
}

QString FolderTreeListing::subject(const QModelIndex& index) const
{
    QString s;
    folder_tree_listing_data_subject(m_d, index.internalId(), &s, set_qstring);
    return s;
}

quint64 FolderTreeListing::uid(const QModelIndex& index) const
{
    return folder_tree_listing_data_uid(m_d, index.internalId());
}

QVariant FolderTreeListing::data(const QModelIndex &index, int role) const
{
    Q_ASSERT(rowCount(index.parent()) > index.row());
    switch (index.column()) {
    case 0:
        switch (role) {
        case Qt::UserRole + 0:
            return cleanNullQVariant(QVariant::fromValue(date(index)));
        case Qt::UserRole + 1:
            return cleanNullQVariant(QVariant::fromValue(from(index)));
        case Qt::UserRole + 2:
            return QVariant::fromValue(section(index));
        case Qt::UserRole + 3:
            return QVariant::fromValue(seen(index));
        case Qt::UserRole + 4:
            return cleanNullQVariant(QVariant::fromValue(subject(index)));
        case Qt::UserRole + 5:
            return QVariant::fromValue(uid(index));
        }
    }
    return QVariant();
}

int FolderTreeListing::role(const char* name) const {
    auto names = roleNames();
    auto i = names.constBegin();
    while (i != names.constEnd()) {
        if (i.value() == name) {
            return i.key();
        }
        ++i;
    }
    return -1;
}
QHash<int, QByteArray> FolderTreeListing::roleNames() const {
    QHash<int, QByteArray> names = QAbstractItemModel::roleNames();
    names.insert(Qt::UserRole + 0, "date");
    names.insert(Qt::UserRole + 1, "from");
    names.insert(Qt::UserRole + 2, "section");
    names.insert(Qt::UserRole + 3, "seen");
    names.insert(Qt::UserRole + 4, "subject");
    names.insert(Qt::UserRole + 5, "uid");
    return names;
}
QVariant FolderTreeListing::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (orientation != Qt::Horizontal) {
        return QVariant();
    }
    return m_headerData.value(qMakePair(section, (Qt::ItemDataRole)role), role == Qt::DisplayRole ?QString::number(section + 1) :QVariant());
}

bool FolderTreeListing::setHeaderData(int section, Qt::Orientation orientation, const QVariant &value, int role)
{
    if (orientation != Qt::Horizontal) {
        return false;
    }
    m_headerData.insert(qMakePair(section, (Qt::ItemDataRole)role), value);
    return true;
}

extern "C" {
    FolderTreeListing::Private* folder_tree_listing_new(FolderTreeListing*,
        void (*)(const FolderTreeListing*, option_quintptr),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, quintptr, quintptr),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, option_quintptr, int, int),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, option_quintptr, int, int, option_quintptr, int),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, option_quintptr, int, int),
        void (*)(FolderTreeListing*));
    void folder_tree_listing_free(FolderTreeListing::Private*);
    void folder_tree_listing_set_filter(FolderTreeListing::Private*, const ushort*, int);
};

extern "C" {
    void mail_folders_data_delimiter(const MailFolders::Private*, quintptr, QString*, qstring_set);
    void mail_folders_data_name(const MailFolders::Private*, quintptr, QString*, qstring_set);
    void mail_folders_sort(MailFolders::Private*, unsigned char column, Qt::SortOrder order = Qt::AscendingOrder);

    int mail_folders_row_count(const MailFolders::Private*, option_quintptr);
    bool mail_folders_can_fetch_more(const MailFolders::Private*, option_quintptr);
    void mail_folders_fetch_more(MailFolders::Private*, option_quintptr);
    quintptr mail_folders_index(const MailFolders::Private*, option_quintptr, int);
    qmodelindex_t mail_folders_parent(const MailFolders::Private*, quintptr);
    int mail_folders_row(const MailFolders::Private*, quintptr);
    option_quintptr mail_folders_check_row(const MailFolders::Private*, quintptr, int);
}
int MailFolders::columnCount(const QModelIndex &) const
{
    return 1;
}

bool MailFolders::hasChildren(const QModelIndex &parent) const
{
    return rowCount(parent) > 0;
}

int MailFolders::rowCount(const QModelIndex &parent) const
{
    if (parent.isValid() && parent.column() != 0) {
        return 0;
    }
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    return mail_folders_row_count(m_d, rust_parent);
}

bool MailFolders::insertRows(int, int, const QModelIndex &)
{
    return false; // not supported yet
}

bool MailFolders::removeRows(int, int, const QModelIndex &)
{
    return false; // not supported yet
}

QModelIndex MailFolders::index(int row, int column, const QModelIndex &parent) const
{
    if (row < 0 || column < 0 || column >= 1) {
        return QModelIndex();
    }
    if (parent.isValid() && parent.column() != 0) {
        return QModelIndex();
    }
    if (row >= rowCount(parent)) {
        return QModelIndex();
    }
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    const quintptr id = mail_folders_index(m_d, rust_parent, row);
    return createIndex(row, column, id);
}

QModelIndex MailFolders::parent(const QModelIndex &index) const
{
    if (!index.isValid()) {
        return QModelIndex();
    }
    const qmodelindex_t parent = mail_folders_parent(m_d, index.internalId());
    return parent.row >= 0 ?createIndex(parent.row, 0, parent.id) :QModelIndex();
}

bool MailFolders::canFetchMore(const QModelIndex &parent) const
{
    if (parent.isValid() && parent.column() != 0) {
        return false;
    }
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    return mail_folders_can_fetch_more(m_d, rust_parent);
}

void MailFolders::fetchMore(const QModelIndex &parent)
{
    const option_quintptr rust_parent = {
        parent.internalId(),
        parent.isValid()
    };
    mail_folders_fetch_more(m_d, rust_parent);
}
void MailFolders::updatePersistentIndexes() {
    const auto from = persistentIndexList();
    auto to = from;
    auto len = to.size();
    for (int i = 0; i < len; ++i) {
        auto index = to.at(i);
        auto row = mail_folders_check_row(m_d, index.internalId(), index.row());
        if (row.some) {
            to[i] = createIndex(row.value, index.column(), index.internalId());
        } else {
            to[i] = QModelIndex();
        }
    }
    changePersistentIndexList(from, to);
}

void MailFolders::sort(int column, Qt::SortOrder order)
{
    mail_folders_sort(m_d, column, order);
}
Qt::ItemFlags MailFolders::flags(const QModelIndex &i) const
{
    auto flags = QAbstractItemModel::flags(i);
    return flags;
}

QString MailFolders::delimiter(const QModelIndex& index) const
{
    QString s;
    mail_folders_data_delimiter(m_d, index.internalId(), &s, set_qstring);
    return s;
}

QString MailFolders::name(const QModelIndex& index) const
{
    QString s;
    mail_folders_data_name(m_d, index.internalId(), &s, set_qstring);
    return s;
}

QVariant MailFolders::data(const QModelIndex &index, int role) const
{
    Q_ASSERT(rowCount(index.parent()) > index.row());
    switch (index.column()) {
    case 0:
        switch (role) {
        case Qt::UserRole + 0:
            return QVariant::fromValue(delimiter(index));
        case Qt::UserRole + 1:
            return QVariant::fromValue(name(index));
        }
    }
    return QVariant();
}

int MailFolders::role(const char* name) const {
    auto names = roleNames();
    auto i = names.constBegin();
    while (i != names.constEnd()) {
        if (i.value() == name) {
            return i.key();
        }
        ++i;
    }
    return -1;
}
QHash<int, QByteArray> MailFolders::roleNames() const {
    QHash<int, QByteArray> names = QAbstractItemModel::roleNames();
    names.insert(Qt::UserRole + 0, "delimiter");
    names.insert(Qt::UserRole + 1, "name");
    return names;
}
QVariant MailFolders::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (orientation != Qt::Horizontal) {
        return QVariant();
    }
    return m_headerData.value(qMakePair(section, (Qt::ItemDataRole)role), role == Qt::DisplayRole ?QString::number(section + 1) :QVariant());
}

bool MailFolders::setHeaderData(int section, Qt::Orientation orientation, const QVariant &value, int role)
{
    if (orientation != Qt::Horizontal) {
        return false;
    }
    m_headerData.insert(qMakePair(section, (Qt::ItemDataRole)role), value);
    return true;
}

extern "C" {
    MailFolders::Private* mail_folders_new(MailFolders*,
        void (*)(const MailFolders*, option_quintptr),
        void (*)(MailFolders*),
        void (*)(MailFolders*),
        void (*)(MailFolders*, quintptr, quintptr),
        void (*)(MailFolders*),
        void (*)(MailFolders*),
        void (*)(MailFolders*, option_quintptr, int, int),
        void (*)(MailFolders*),
        void (*)(MailFolders*, option_quintptr, int, int, option_quintptr, int),
        void (*)(MailFolders*),
        void (*)(MailFolders*, option_quintptr, int, int),
        void (*)(MailFolders*));
    void mail_folders_free(MailFolders::Private*);
};

extern "C" {
    MailModel::Private* mail_model_new(MailModel*, void (*)(MailModel*), void (*)(MailModel*), Email*, Attachments*,
        void (*)(const Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*, quintptr, quintptr),
        void (*)(Attachments*),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int, int),
        void (*)(Attachments*),
        void (*)(Attachments*, int, int),
        void (*)(Attachments*), void (*)(Email*), void (*)(Email*), void (*)(Email*), void (*)(Email*), void (*)(Email*), FolderTreeListing*,
        void (*)(const FolderTreeListing*, option_quintptr),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, quintptr, quintptr),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, option_quintptr, int, int),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, option_quintptr, int, int, option_quintptr, int),
        void (*)(FolderTreeListing*),
        void (*)(FolderTreeListing*, option_quintptr, int, int),
        void (*)(FolderTreeListing*), MailFolders*,
        void (*)(const MailFolders*, option_quintptr),
        void (*)(MailFolders*),
        void (*)(MailFolders*),
        void (*)(MailFolders*, quintptr, quintptr),
        void (*)(MailFolders*),
        void (*)(MailFolders*),
        void (*)(MailFolders*, option_quintptr, int, int),
        void (*)(MailFolders*),
        void (*)(MailFolders*, option_quintptr, int, int, option_quintptr, int),
        void (*)(MailFolders*),
        void (*)(MailFolders*, option_quintptr, int, int),
        void (*)(MailFolders*));
    void mail_model_free(MailModel::Private*);
    void mail_model_config_file_get(const MailModel::Private*, QString*, qstring_set);
    void mail_model_config_file_set(MailModel::Private*, const ushort *str, int len);
    void mail_model_config_file_set_none(MailModel::Private*);
    void mail_model_current_folder_get(const MailModel::Private*, QString*, qstring_set);
    void mail_model_current_folder_set(MailModel::Private*, const ushort *str, int len);
    Email::Private* mail_model_email_get(const MailModel::Private*);
    FolderTreeListing::Private* mail_model_folder_threads_get(const MailModel::Private*);
    MailFolders::Private* mail_model_folders_get(const MailModel::Private*);
    void mail_model_set_email(MailModel::Private*, quint64);
};

Attachments::Attachments(bool /*owned*/, QObject *parent):
    QAbstractItemModel(parent),
    m_d(0),
    m_ownsPrivate(false)
{
    initHeaderData();
}

Attachments::Attachments(QObject *parent):
    QAbstractItemModel(parent),
    m_d(attachments_new(this,
        [](const Attachments* o) {
            emit o->newDataReady(QModelIndex());
        },
        [](Attachments* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](Attachments* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](Attachments* o, quintptr first, quintptr last) {
            o->dataChanged(o->createIndex(first, 0, first),
                       o->createIndex(last, 0, last));
        },
        [](Attachments* o) {
            o->beginResetModel();
        },
        [](Attachments* o) {
            o->endResetModel();
        },
        [](Attachments* o, int first, int last) {
            o->beginInsertRows(QModelIndex(), first, last);
        },
        [](Attachments* o) {
            o->endInsertRows();
        },
        [](Attachments* o, int first, int last, int destination) {
            o->beginMoveRows(QModelIndex(), first, last, QModelIndex(), destination);
        },
        [](Attachments* o) {
            o->endMoveRows();
        },
        [](Attachments* o, int first, int last) {
            o->beginRemoveRows(QModelIndex(), first, last);
        },
        [](Attachments* o) {
            o->endRemoveRows();
        }
)),
    m_ownsPrivate(true)
{
    connect(this, &Attachments::newDataReady, this, [this](const QModelIndex& i) {
        this->fetchMore(i);
    }, Qt::QueuedConnection);
    initHeaderData();
}

Attachments::~Attachments() {
    if (m_ownsPrivate) {
        attachments_free(m_d);
    }
}
void Attachments::initHeaderData() {
}
QString Attachments::saveToFolder(quint32 index, const QString& folder) const
{
    QString s;
    attachments_save_to_folder(m_d, index, folder.utf16(), folder.size(), &s, set_qstring);
    return s;
}
Email::Email(bool /*owned*/, QObject *parent):
    QObject(parent),
    m_attachments(new Attachments(false, this)),
    m_d(0),
    m_ownsPrivate(false)
{
}

Email::Email(QObject *parent):
    QObject(parent),
    m_attachments(new Attachments(false, this)),
    m_d(email_new(this, m_attachments,
        [](const Attachments* o) {
            emit o->newDataReady(QModelIndex());
        },
        [](Attachments* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](Attachments* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](Attachments* o, quintptr first, quintptr last) {
            o->dataChanged(o->createIndex(first, 0, first),
                       o->createIndex(last, 0, last));
        },
        [](Attachments* o) {
            o->beginResetModel();
        },
        [](Attachments* o) {
            o->endResetModel();
        },
        [](Attachments* o, int first, int last) {
            o->beginInsertRows(QModelIndex(), first, last);
        },
        [](Attachments* o) {
            o->endInsertRows();
        },
        [](Attachments* o, int first, int last, int destination) {
            o->beginMoveRows(QModelIndex(), first, last, QModelIndex(), destination);
        },
        [](Attachments* o) {
            o->endMoveRows();
        },
        [](Attachments* o, int first, int last) {
            o->beginRemoveRows(QModelIndex(), first, last);
        },
        [](Attachments* o) {
            o->endRemoveRows();
        }
,
        emailBodyChanged,
        emailDateChanged,
        emailFromChanged,
        emailHtmlChanged,
        emailSubjectChanged)),
    m_ownsPrivate(true)
{
    m_attachments->m_d = email_attachments_get(m_d);
    connect(this->m_attachments, &Attachments::newDataReady, this->m_attachments, [this](const QModelIndex& i) {
        this->m_attachments->fetchMore(i);
    }, Qt::QueuedConnection);
}

Email::~Email() {
    if (m_ownsPrivate) {
        email_free(m_d);
    }
}
const Attachments* Email::attachments() const
{
    return m_attachments;
}
Attachments* Email::attachments()
{
    return m_attachments;
}
QString Email::body() const
{
    QString v;
    email_body_get(m_d, &v, set_qstring);
    return v;
}
QString Email::date() const
{
    QString v;
    email_date_get(m_d, &v, set_qstring);
    return v;
}
QString Email::from() const
{
    QString v;
    email_from_get(m_d, &v, set_qstring);
    return v;
}
QString Email::html() const
{
    QString v;
    email_html_get(m_d, &v, set_qstring);
    return v;
}
QString Email::subject() const
{
    QString v;
    email_subject_get(m_d, &v, set_qstring);
    return v;
}
FolderTreeListing::FolderTreeListing(bool /*owned*/, QObject *parent):
    QAbstractItemModel(parent),
    m_d(0),
    m_ownsPrivate(false)
{
    initHeaderData();
}

FolderTreeListing::FolderTreeListing(QObject *parent):
    QAbstractItemModel(parent),
    m_d(folder_tree_listing_new(this,
        [](const FolderTreeListing* o, option_quintptr id) {
            if (id.some) {
                int row = folder_tree_listing_row(o->m_d, id.value);
                emit o->newDataReady(o->createIndex(row, 0, id.value));
            } else {
                emit o->newDataReady(QModelIndex());
            }
        },
        [](FolderTreeListing* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](FolderTreeListing* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](FolderTreeListing* o, quintptr first, quintptr last) {
            quintptr frow = folder_tree_listing_row(o->m_d, first);
            quintptr lrow = folder_tree_listing_row(o->m_d, first);
            o->dataChanged(o->createIndex(frow, 0, first),
                       o->createIndex(lrow, 0, last));
        },
        [](FolderTreeListing* o) {
            o->beginResetModel();
        },
        [](FolderTreeListing* o) {
            o->endResetModel();
        },
        [](FolderTreeListing* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = folder_tree_listing_row(o->m_d, id.value);
                o->beginInsertRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginInsertRows(QModelIndex(), first, last);
            }
        },
        [](FolderTreeListing* o) {
            o->endInsertRows();
        },
        [](FolderTreeListing* o, option_quintptr sourceParent, int first, int last, option_quintptr destinationParent, int destination) {
            QModelIndex s;
            if (sourceParent.some) {
                int row = folder_tree_listing_row(o->m_d, sourceParent.value);
                s = o->createIndex(row, 0, sourceParent.value);
            }
            QModelIndex d;
            if (destinationParent.some) {
                int row = folder_tree_listing_row(o->m_d, destinationParent.value);
                d = o->createIndex(row, 0, destinationParent.value);
            }
            o->beginMoveRows(s, first, last, d, destination);
        },
        [](FolderTreeListing* o) {
            o->endMoveRows();
        },
        [](FolderTreeListing* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = folder_tree_listing_row(o->m_d, id.value);
                o->beginRemoveRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginRemoveRows(QModelIndex(), first, last);
            }
        },
        [](FolderTreeListing* o) {
            o->endRemoveRows();
        }
)),
    m_ownsPrivate(true)
{
    connect(this, &FolderTreeListing::newDataReady, this, [this](const QModelIndex& i) {
        this->fetchMore(i);
    }, Qt::QueuedConnection);
    initHeaderData();
}

FolderTreeListing::~FolderTreeListing() {
    if (m_ownsPrivate) {
        folder_tree_listing_free(m_d);
    }
}
void FolderTreeListing::initHeaderData() {
}
void FolderTreeListing::setFilter(const QString& filter)
{
    return folder_tree_listing_set_filter(m_d, filter.utf16(), filter.size());
}
MailFolders::MailFolders(bool /*owned*/, QObject *parent):
    QAbstractItemModel(parent),
    m_d(0),
    m_ownsPrivate(false)
{
    initHeaderData();
}

MailFolders::MailFolders(QObject *parent):
    QAbstractItemModel(parent),
    m_d(mail_folders_new(this,
        [](const MailFolders* o, option_quintptr id) {
            if (id.some) {
                int row = mail_folders_row(o->m_d, id.value);
                emit o->newDataReady(o->createIndex(row, 0, id.value));
            } else {
                emit o->newDataReady(QModelIndex());
            }
        },
        [](MailFolders* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](MailFolders* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](MailFolders* o, quintptr first, quintptr last) {
            quintptr frow = mail_folders_row(o->m_d, first);
            quintptr lrow = mail_folders_row(o->m_d, first);
            o->dataChanged(o->createIndex(frow, 0, first),
                       o->createIndex(lrow, 0, last));
        },
        [](MailFolders* o) {
            o->beginResetModel();
        },
        [](MailFolders* o) {
            o->endResetModel();
        },
        [](MailFolders* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = mail_folders_row(o->m_d, id.value);
                o->beginInsertRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginInsertRows(QModelIndex(), first, last);
            }
        },
        [](MailFolders* o) {
            o->endInsertRows();
        },
        [](MailFolders* o, option_quintptr sourceParent, int first, int last, option_quintptr destinationParent, int destination) {
            QModelIndex s;
            if (sourceParent.some) {
                int row = mail_folders_row(o->m_d, sourceParent.value);
                s = o->createIndex(row, 0, sourceParent.value);
            }
            QModelIndex d;
            if (destinationParent.some) {
                int row = mail_folders_row(o->m_d, destinationParent.value);
                d = o->createIndex(row, 0, destinationParent.value);
            }
            o->beginMoveRows(s, first, last, d, destination);
        },
        [](MailFolders* o) {
            o->endMoveRows();
        },
        [](MailFolders* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = mail_folders_row(o->m_d, id.value);
                o->beginRemoveRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginRemoveRows(QModelIndex(), first, last);
            }
        },
        [](MailFolders* o) {
            o->endRemoveRows();
        }
)),
    m_ownsPrivate(true)
{
    connect(this, &MailFolders::newDataReady, this, [this](const QModelIndex& i) {
        this->fetchMore(i);
    }, Qt::QueuedConnection);
    initHeaderData();
}

MailFolders::~MailFolders() {
    if (m_ownsPrivate) {
        mail_folders_free(m_d);
    }
}
void MailFolders::initHeaderData() {
}
MailModel::MailModel(bool /*owned*/, QObject *parent):
    QObject(parent),
    m_email(new Email(false, this)),
    m_folder_threads(new FolderTreeListing(false, this)),
    m_folders(new MailFolders(false, this)),
    m_d(0),
    m_ownsPrivate(false)
{
}

MailModel::MailModel(QObject *parent):
    QObject(parent),
    m_email(new Email(false, this)),
    m_folder_threads(new FolderTreeListing(false, this)),
    m_folders(new MailFolders(false, this)),
    m_d(mail_model_new(this,
        mailModelConfigFileChanged,
        mailModelCurrentFolderChanged, m_email, m_email->m_attachments,
        [](const Attachments* o) {
            emit o->newDataReady(QModelIndex());
        },
        [](Attachments* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](Attachments* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](Attachments* o, quintptr first, quintptr last) {
            o->dataChanged(o->createIndex(first, 0, first),
                       o->createIndex(last, 0, last));
        },
        [](Attachments* o) {
            o->beginResetModel();
        },
        [](Attachments* o) {
            o->endResetModel();
        },
        [](Attachments* o, int first, int last) {
            o->beginInsertRows(QModelIndex(), first, last);
        },
        [](Attachments* o) {
            o->endInsertRows();
        },
        [](Attachments* o, int first, int last, int destination) {
            o->beginMoveRows(QModelIndex(), first, last, QModelIndex(), destination);
        },
        [](Attachments* o) {
            o->endMoveRows();
        },
        [](Attachments* o, int first, int last) {
            o->beginRemoveRows(QModelIndex(), first, last);
        },
        [](Attachments* o) {
            o->endRemoveRows();
        }
,
        emailBodyChanged,
        emailDateChanged,
        emailFromChanged,
        emailHtmlChanged,
        emailSubjectChanged, m_folder_threads,
        [](const FolderTreeListing* o, option_quintptr id) {
            if (id.some) {
                int row = folder_tree_listing_row(o->m_d, id.value);
                emit o->newDataReady(o->createIndex(row, 0, id.value));
            } else {
                emit o->newDataReady(QModelIndex());
            }
        },
        [](FolderTreeListing* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](FolderTreeListing* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](FolderTreeListing* o, quintptr first, quintptr last) {
            quintptr frow = folder_tree_listing_row(o->m_d, first);
            quintptr lrow = folder_tree_listing_row(o->m_d, first);
            o->dataChanged(o->createIndex(frow, 0, first),
                       o->createIndex(lrow, 0, last));
        },
        [](FolderTreeListing* o) {
            o->beginResetModel();
        },
        [](FolderTreeListing* o) {
            o->endResetModel();
        },
        [](FolderTreeListing* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = folder_tree_listing_row(o->m_d, id.value);
                o->beginInsertRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginInsertRows(QModelIndex(), first, last);
            }
        },
        [](FolderTreeListing* o) {
            o->endInsertRows();
        },
        [](FolderTreeListing* o, option_quintptr sourceParent, int first, int last, option_quintptr destinationParent, int destination) {
            QModelIndex s;
            if (sourceParent.some) {
                int row = folder_tree_listing_row(o->m_d, sourceParent.value);
                s = o->createIndex(row, 0, sourceParent.value);
            }
            QModelIndex d;
            if (destinationParent.some) {
                int row = folder_tree_listing_row(o->m_d, destinationParent.value);
                d = o->createIndex(row, 0, destinationParent.value);
            }
            o->beginMoveRows(s, first, last, d, destination);
        },
        [](FolderTreeListing* o) {
            o->endMoveRows();
        },
        [](FolderTreeListing* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = folder_tree_listing_row(o->m_d, id.value);
                o->beginRemoveRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginRemoveRows(QModelIndex(), first, last);
            }
        },
        [](FolderTreeListing* o) {
            o->endRemoveRows();
        }
, m_folders,
        [](const MailFolders* o, option_quintptr id) {
            if (id.some) {
                int row = mail_folders_row(o->m_d, id.value);
                emit o->newDataReady(o->createIndex(row, 0, id.value));
            } else {
                emit o->newDataReady(QModelIndex());
            }
        },
        [](MailFolders* o) {
            emit o->layoutAboutToBeChanged();
        },
        [](MailFolders* o) {
            o->updatePersistentIndexes();
            emit o->layoutChanged();
        },
        [](MailFolders* o, quintptr first, quintptr last) {
            quintptr frow = mail_folders_row(o->m_d, first);
            quintptr lrow = mail_folders_row(o->m_d, first);
            o->dataChanged(o->createIndex(frow, 0, first),
                       o->createIndex(lrow, 0, last));
        },
        [](MailFolders* o) {
            o->beginResetModel();
        },
        [](MailFolders* o) {
            o->endResetModel();
        },
        [](MailFolders* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = mail_folders_row(o->m_d, id.value);
                o->beginInsertRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginInsertRows(QModelIndex(), first, last);
            }
        },
        [](MailFolders* o) {
            o->endInsertRows();
        },
        [](MailFolders* o, option_quintptr sourceParent, int first, int last, option_quintptr destinationParent, int destination) {
            QModelIndex s;
            if (sourceParent.some) {
                int row = mail_folders_row(o->m_d, sourceParent.value);
                s = o->createIndex(row, 0, sourceParent.value);
            }
            QModelIndex d;
            if (destinationParent.some) {
                int row = mail_folders_row(o->m_d, destinationParent.value);
                d = o->createIndex(row, 0, destinationParent.value);
            }
            o->beginMoveRows(s, first, last, d, destination);
        },
        [](MailFolders* o) {
            o->endMoveRows();
        },
        [](MailFolders* o, option_quintptr id, int first, int last) {
            if (id.some) {
                int row = mail_folders_row(o->m_d, id.value);
                o->beginRemoveRows(o->createIndex(row, 0, id.value), first, last);
            } else {
                o->beginRemoveRows(QModelIndex(), first, last);
            }
        },
        [](MailFolders* o) {
            o->endRemoveRows();
        }
)),
    m_ownsPrivate(true)
{
    m_email->m_d = mail_model_email_get(m_d);
    m_email->m_attachments->m_d = email_attachments_get(m_email->m_d);
    m_folder_threads->m_d = mail_model_folder_threads_get(m_d);
    m_folders->m_d = mail_model_folders_get(m_d);
    connect(this->m_email->m_attachments, &Attachments::newDataReady, this->m_email->m_attachments, [this](const QModelIndex& i) {
        this->m_email->m_attachments->fetchMore(i);
    }, Qt::QueuedConnection);
    connect(this->m_folder_threads, &FolderTreeListing::newDataReady, this->m_folder_threads, [this](const QModelIndex& i) {
        this->m_folder_threads->fetchMore(i);
    }, Qt::QueuedConnection);
    connect(this->m_folders, &MailFolders::newDataReady, this->m_folders, [this](const QModelIndex& i) {
        this->m_folders->fetchMore(i);
    }, Qt::QueuedConnection);
}

MailModel::~MailModel() {
    if (m_ownsPrivate) {
        mail_model_free(m_d);
    }
}
QString MailModel::configFile() const
{
    QString v;
    mail_model_config_file_get(m_d, &v, set_qstring);
    return v;
}
void MailModel::setConfigFile(const QString& v) {
    if (v.isNull()) {
        mail_model_config_file_set_none(m_d);
    } else {
    mail_model_config_file_set(m_d, reinterpret_cast<const ushort*>(v.data()), v.size());
    }
}
QString MailModel::currentFolder() const
{
    QString v;
    mail_model_current_folder_get(m_d, &v, set_qstring);
    return v;
}
void MailModel::setCurrentFolder(const QString& v) {
    mail_model_current_folder_set(m_d, reinterpret_cast<const ushort*>(v.data()), v.size());
}
const Email* MailModel::email() const
{
    return m_email;
}
Email* MailModel::email()
{
    return m_email;
}
const FolderTreeListing* MailModel::folder_threads() const
{
    return m_folder_threads;
}
FolderTreeListing* MailModel::folder_threads()
{
    return m_folder_threads;
}
const MailFolders* MailModel::folders() const
{
    return m_folders;
}
MailFolders* MailModel::folders()
{
    return m_folders;
}
void MailModel::setEmail(quint64 uid)
{
    return mail_model_set_email(m_d, uid);
}
