/* generated by rust_qt_binding_generator */
#ifndef BINDINGS_H
#define BINDINGS_H

#include <QtCore/QObject>
#include <QtCore/QAbstractItemModel>

class Attachments;
class Email;
class FolderTreeListing;
class MailFolders;
class MailModel;

class Attachments : public QAbstractItemModel
{
    Q_OBJECT
    friend class Email;
    friend class MailModel;
public:
    class Private;
private:
    Private * m_d;
    bool m_ownsPrivate;
    explicit Attachments(bool owned, QObject *parent);
public:
    explicit Attachments(QObject *parent = nullptr);
    ~Attachments();
    Q_INVOKABLE QString saveToFolder(quint32 index, const QString& folder) const;

    int columnCount(const QModelIndex &parent = QModelIndex()) const override;
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const override;
    QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const override;
    QModelIndex parent(const QModelIndex &index) const override;
    bool hasChildren(const QModelIndex &parent = QModelIndex()) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    bool canFetchMore(const QModelIndex &parent) const override;
    void fetchMore(const QModelIndex &parent) override;
    Qt::ItemFlags flags(const QModelIndex &index) const override;
    void sort(int column, Qt::SortOrder order = Qt::AscendingOrder) override;
    int role(const char* name) const;
    QHash<int, QByteArray> roleNames() const override;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
    bool setHeaderData(int section, Qt::Orientation orientation, const QVariant &value, int role = Qt::EditRole) override;
    Q_INVOKABLE bool insertRows(int row, int count, const QModelIndex &parent = QModelIndex()) override;
    Q_INVOKABLE bool removeRows(int row, int count, const QModelIndex &parent = QModelIndex()) override;
    Q_INVOKABLE QByteArray bytes(int row) const;
    Q_INVOKABLE QString name(int row) const;

signals:
    // new data is ready to be made available to the model with fetchMore()
    void newDataReady(const QModelIndex &parent) const;
private:
    QHash<QPair<int,Qt::ItemDataRole>, QVariant> m_headerData;
    void initHeaderData();
    void updatePersistentIndexes();
signals:
};

class Email : public QObject
{
    Q_OBJECT
    friend class MailModel;
public:
    class Private;
private:
    Attachments* const m_attachments;
    Private * m_d;
    bool m_ownsPrivate;
    Q_PROPERTY(Attachments* attachments READ attachments NOTIFY attachmentsChanged FINAL)
    Q_PROPERTY(QString body READ body NOTIFY bodyChanged FINAL)
    Q_PROPERTY(QString date READ date NOTIFY dateChanged FINAL)
    Q_PROPERTY(QString from READ from NOTIFY fromChanged FINAL)
    Q_PROPERTY(QString html READ html NOTIFY htmlChanged FINAL)
    Q_PROPERTY(QString subject READ subject NOTIFY subjectChanged FINAL)
    explicit Email(bool owned, QObject *parent);
public:
    explicit Email(QObject *parent = nullptr);
    ~Email();
    const Attachments* attachments() const;
    Attachments* attachments();
    QString body() const;
    QString date() const;
    QString from() const;
    QString html() const;
    QString subject() const;
signals:
    void attachmentsChanged();
    void bodyChanged();
    void dateChanged();
    void fromChanged();
    void htmlChanged();
    void subjectChanged();
};

class FolderTreeListing : public QAbstractItemModel
{
    Q_OBJECT
    friend class Email;
    friend class MailModel;
public:
    class Private;
private:
    Private * m_d;
    bool m_ownsPrivate;
    explicit FolderTreeListing(bool owned, QObject *parent);
public:
    explicit FolderTreeListing(QObject *parent = nullptr);
    ~FolderTreeListing();
    Q_INVOKABLE void setFilter(const QString& filter);

    int columnCount(const QModelIndex &parent = QModelIndex()) const override;
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const override;
    QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const override;
    QModelIndex parent(const QModelIndex &index) const override;
    bool hasChildren(const QModelIndex &parent = QModelIndex()) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    bool canFetchMore(const QModelIndex &parent) const override;
    void fetchMore(const QModelIndex &parent) override;
    Qt::ItemFlags flags(const QModelIndex &index) const override;
    void sort(int column, Qt::SortOrder order = Qt::AscendingOrder) override;
    int role(const char* name) const;
    QHash<int, QByteArray> roleNames() const override;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
    bool setHeaderData(int section, Qt::Orientation orientation, const QVariant &value, int role = Qt::EditRole) override;
    Q_INVOKABLE bool insertRows(int row, int count, const QModelIndex &parent = QModelIndex()) override;
    Q_INVOKABLE bool removeRows(int row, int count, const QModelIndex &parent = QModelIndex()) override;
    Q_INVOKABLE QString date(const QModelIndex& index) const;
    Q_INVOKABLE QString from(const QModelIndex& index) const;
    Q_INVOKABLE QString section(const QModelIndex& index) const;
    Q_INVOKABLE bool seen(const QModelIndex& index) const;
    Q_INVOKABLE QString subject(const QModelIndex& index) const;
    Q_INVOKABLE quint64 uid(const QModelIndex& index) const;

signals:
    // new data is ready to be made available to the model with fetchMore()
    void newDataReady(const QModelIndex &parent) const;
private:
    QHash<QPair<int,Qt::ItemDataRole>, QVariant> m_headerData;
    void initHeaderData();
    void updatePersistentIndexes();
signals:
};

class MailFolders : public QAbstractItemModel
{
    Q_OBJECT
    friend class Email;
    friend class MailModel;
public:
    class Private;
private:
    Private * m_d;
    bool m_ownsPrivate;
    explicit MailFolders(bool owned, QObject *parent);
public:
    explicit MailFolders(QObject *parent = nullptr);
    ~MailFolders();

    int columnCount(const QModelIndex &parent = QModelIndex()) const override;
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const override;
    QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const override;
    QModelIndex parent(const QModelIndex &index) const override;
    bool hasChildren(const QModelIndex &parent = QModelIndex()) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    bool canFetchMore(const QModelIndex &parent) const override;
    void fetchMore(const QModelIndex &parent) override;
    Qt::ItemFlags flags(const QModelIndex &index) const override;
    void sort(int column, Qt::SortOrder order = Qt::AscendingOrder) override;
    int role(const char* name) const;
    QHash<int, QByteArray> roleNames() const override;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
    bool setHeaderData(int section, Qt::Orientation orientation, const QVariant &value, int role = Qt::EditRole) override;
    Q_INVOKABLE bool insertRows(int row, int count, const QModelIndex &parent = QModelIndex()) override;
    Q_INVOKABLE bool removeRows(int row, int count, const QModelIndex &parent = QModelIndex()) override;
    Q_INVOKABLE QString delimiter(const QModelIndex& index) const;
    Q_INVOKABLE QString name(const QModelIndex& index) const;

signals:
    // new data is ready to be made available to the model with fetchMore()
    void newDataReady(const QModelIndex &parent) const;
private:
    QHash<QPair<int,Qt::ItemDataRole>, QVariant> m_headerData;
    void initHeaderData();
    void updatePersistentIndexes();
signals:
};

class MailModel : public QObject
{
    Q_OBJECT
    friend class Email;
public:
    class Private;
private:
    Email* const m_email;
    FolderTreeListing* const m_folder_threads;
    MailFolders* const m_folders;
    Private * m_d;
    bool m_ownsPrivate;
    Q_PROPERTY(QString configFile READ configFile WRITE setConfigFile NOTIFY configFileChanged FINAL)
    Q_PROPERTY(QString currentFolder READ currentFolder WRITE setCurrentFolder NOTIFY currentFolderChanged FINAL)
    Q_PROPERTY(Email* email READ email NOTIFY emailChanged FINAL)
    Q_PROPERTY(FolderTreeListing* folder_threads READ folder_threads NOTIFY folder_threadsChanged FINAL)
    Q_PROPERTY(MailFolders* folders READ folders NOTIFY foldersChanged FINAL)
    explicit MailModel(bool owned, QObject *parent);
public:
    explicit MailModel(QObject *parent = nullptr);
    ~MailModel();
    QString configFile() const;
    void setConfigFile(const QString& v);
    QString currentFolder() const;
    void setCurrentFolder(const QString& v);
    const Email* email() const;
    Email* email();
    const FolderTreeListing* folder_threads() const;
    FolderTreeListing* folder_threads();
    const MailFolders* folders() const;
    MailFolders* folders();
    Q_INVOKABLE void setEmail(quint64 uid);
signals:
    void configFileChanged();
    void currentFolderChanged();
    void emailChanged();
    void folder_threadsChanged();
    void foldersChanged();
};
#endif // BINDINGS_H
