/* generated by rust_qt_binding_generator */
#![allow(unknown_lints)]
#![allow(mutex_atomic, needless_pass_by_value)]
use libc::{c_char, c_int, c_ushort};
use std::char::decode_utf16;
use std::slice;

use std::ptr::null;
use std::sync::{Arc, Mutex};

use implementation::*;

#[repr(C)]
pub struct COption<T> {
    data: T,
    some: bool,
}

impl<T> COption<T> {
    #![allow(dead_code)]
    fn into(self) -> Option<T> {
        if self.some {
            Some(self.data)
        } else {
            None
        }
    }
}

impl<T> From<Option<T>> for COption<T>
where
    T: Default,
{
    fn from(t: Option<T>) -> COption<T> {
        if let Some(v) = t {
            COption {
                data: v,
                some: true,
            }
        } else {
            COption {
                data: T::default(),
                some: false,
            }
        }
    }
}

pub enum QString {}

fn set_string_from_utf16(s: &mut String, str: *const c_ushort, len: c_int) {
    let utf16 = unsafe { slice::from_raw_parts(str, to_usize(len)) };
    let characters = decode_utf16(utf16.iter().cloned()).map(|r| r.unwrap());
    s.clear();
    s.extend(characters);
}

pub enum QByteArray {}

#[repr(C)]
#[derive(PartialEq, Eq, Debug)]
pub enum SortOrder {
    Ascending = 0,
    Descending = 1,
}

#[repr(C)]
pub struct QModelIndex {
    row: c_int,
    internal_id: usize,
}

fn to_usize(n: c_int) -> usize {
    if n < 0 {
        panic!("Cannot cast {} to usize", n);
    }
    n as usize
}

fn to_c_int(n: usize) -> c_int {
    if n > c_int::max_value() as usize {
        panic!("Cannot cast {} to c_int", n);
    }
    n as c_int
}

pub struct AttachmentsQObject {}

#[derive(Clone)]
pub struct AttachmentsEmitter {
    qobject: Arc<Mutex<*const AttachmentsQObject>>,
    new_data_ready: fn(*const AttachmentsQObject),
}

unsafe impl Send for AttachmentsEmitter {}

impl AttachmentsEmitter {
    fn clear(&self) {
        *self.qobject.lock().unwrap() = null();
    }
    pub fn new_data_ready(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.new_data_ready)(ptr);
        }
    }
}

#[derive(Clone)]
pub struct AttachmentsList {
    qobject: *const AttachmentsQObject,
    layout_about_to_be_changed: fn(*const AttachmentsQObject),
    layout_changed: fn(*const AttachmentsQObject),
    data_changed: fn(*const AttachmentsQObject, usize, usize),
    begin_reset_model: fn(*const AttachmentsQObject),
    end_reset_model: fn(*const AttachmentsQObject),
    begin_insert_rows: fn(*const AttachmentsQObject, usize, usize),
    end_insert_rows: fn(*const AttachmentsQObject),
    begin_move_rows: fn(*const AttachmentsQObject, usize, usize, usize),
    end_move_rows: fn(*const AttachmentsQObject),
    begin_remove_rows: fn(*const AttachmentsQObject, usize, usize),
    end_remove_rows: fn(*const AttachmentsQObject),
}

impl AttachmentsList {
    pub fn layout_about_to_be_changed(&self) {
        (self.layout_about_to_be_changed)(self.qobject);
    }
    pub fn layout_changed(&self) {
        (self.layout_changed)(self.qobject);
    }
    pub fn data_changed(&self, first: usize, last: usize) {
        (self.data_changed)(self.qobject, first, last);
    }
    pub fn begin_reset_model(&self) {
        (self.begin_reset_model)(self.qobject);
    }
    pub fn end_reset_model(&self) {
        (self.end_reset_model)(self.qobject);
    }
    pub fn begin_insert_rows(&self, first: usize, last: usize) {
        (self.begin_insert_rows)(self.qobject, first, last);
    }
    pub fn end_insert_rows(&self) {
        (self.end_insert_rows)(self.qobject);
    }
    pub fn begin_move_rows(&self, first: usize, last: usize, destination: usize) {
        (self.begin_move_rows)(self.qobject, first, last, destination);
    }
    pub fn end_move_rows(&self) {
        (self.end_move_rows)(self.qobject);
    }
    pub fn begin_remove_rows(&self, first: usize, last: usize) {
        (self.begin_remove_rows)(self.qobject, first, last);
    }
    pub fn end_remove_rows(&self) {
        (self.end_remove_rows)(self.qobject);
    }
}

pub trait AttachmentsTrait {
    fn new(emit: AttachmentsEmitter, model: AttachmentsList) -> Self;
    fn emit(&self) -> &AttachmentsEmitter;
    fn save_to_folder(&self, index: u32, folder: String) -> String;
    fn row_count(&self) -> usize;
    fn insert_rows(&mut self, _row: usize, _count: usize) -> bool {
        false
    }
    fn remove_rows(&mut self, _row: usize, _count: usize) -> bool {
        false
    }
    fn can_fetch_more(&self) -> bool {
        false
    }
    fn fetch_more(&mut self) {}
    fn sort(&mut self, u8, SortOrder) {}
    fn bytes(&self, index: usize) -> &[u8];
    fn name(&self, index: usize) -> &str;
}

#[no_mangle]
pub extern "C" fn attachments_new(
    attachments: *mut AttachmentsQObject,
    attachments_new_data_ready: fn(*const AttachmentsQObject),
    attachments_layout_about_to_be_changed: fn(*const AttachmentsQObject),
    attachments_layout_changed: fn(*const AttachmentsQObject),
    attachments_data_changed: fn(*const AttachmentsQObject, usize, usize),
    attachments_begin_reset_model: fn(*const AttachmentsQObject),
    attachments_end_reset_model: fn(*const AttachmentsQObject),
    attachments_begin_insert_rows: fn(*const AttachmentsQObject, usize, usize),
    attachments_end_insert_rows: fn(*const AttachmentsQObject),
    attachments_begin_move_rows: fn(*const AttachmentsQObject, usize, usize, usize),
    attachments_end_move_rows: fn(*const AttachmentsQObject),
    attachments_begin_remove_rows: fn(*const AttachmentsQObject, usize, usize),
    attachments_end_remove_rows: fn(*const AttachmentsQObject),
) -> *mut Attachments {
    let attachments_emit = AttachmentsEmitter {
        qobject: Arc::new(Mutex::new(attachments)),
        new_data_ready: attachments_new_data_ready,
    };
    let model = AttachmentsList {
        qobject: attachments,
        layout_about_to_be_changed: attachments_layout_about_to_be_changed,
        layout_changed: attachments_layout_changed,
        data_changed: attachments_data_changed,
        begin_reset_model: attachments_begin_reset_model,
        end_reset_model: attachments_end_reset_model,
        begin_insert_rows: attachments_begin_insert_rows,
        end_insert_rows: attachments_end_insert_rows,
        begin_move_rows: attachments_begin_move_rows,
        end_move_rows: attachments_end_move_rows,
        begin_remove_rows: attachments_begin_remove_rows,
        end_remove_rows: attachments_end_remove_rows,
    };
    let d_attachments = Attachments::new(attachments_emit, model);
    Box::into_raw(Box::new(d_attachments))
}

#[no_mangle]
pub unsafe extern "C" fn attachments_free(ptr: *mut Attachments) {
    Box::from_raw(ptr).emit().clear();
}

#[no_mangle]
pub unsafe extern "C" fn attachments_save_to_folder(
    ptr: *const Attachments,
    index: u32,
    folder_str: *const c_ushort,
    folder_len: c_int,
    d: *mut QString,
    set: fn(*mut QString, str: *const c_char, len: c_int),
) {
    let mut folder = String::new();
    set_string_from_utf16(&mut folder, folder_str, folder_len);
    let o = &*ptr;
    let r = o.save_to_folder(index, folder);
    let s: *const c_char = r.as_ptr() as (*const c_char);
    set(d, s, r.len() as i32);
}

#[no_mangle]
pub unsafe extern "C" fn attachments_row_count(ptr: *const Attachments) -> c_int {
    to_c_int((&*ptr).row_count())
}
#[no_mangle]
pub unsafe extern "C" fn attachments_insert_rows(
    ptr: *mut Attachments,
    row: c_int,
    count: c_int,
) -> bool {
    (&mut *ptr).insert_rows(to_usize(row), to_usize(count))
}
#[no_mangle]
pub unsafe extern "C" fn attachments_remove_rows(
    ptr: *mut Attachments,
    row: c_int,
    count: c_int,
) -> bool {
    (&mut *ptr).remove_rows(to_usize(row), to_usize(count))
}
#[no_mangle]
pub unsafe extern "C" fn attachments_can_fetch_more(ptr: *const Attachments) -> bool {
    (&*ptr).can_fetch_more()
}
#[no_mangle]
pub unsafe extern "C" fn attachments_fetch_more(ptr: *mut Attachments) {
    (&mut *ptr).fetch_more()
}
#[no_mangle]
pub unsafe extern "C" fn attachments_sort(ptr: *mut Attachments, column: u8, order: SortOrder) {
    (&mut *ptr).sort(column, order)
}

#[no_mangle]
pub unsafe extern "C" fn attachments_data_bytes(
    ptr: *const Attachments,
    row: c_int,
    d: *mut QByteArray,
    set: fn(*mut QByteArray, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.bytes(to_usize(row));
    let s: *const c_char = data.as_ptr() as (*const c_char);
    set(d, s, to_c_int(data.len()));
}

#[no_mangle]
pub unsafe extern "C" fn attachments_data_name(
    ptr: *const Attachments,
    row: c_int,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.name(to_usize(row));
    let s: *const c_char = data.as_ptr() as (*const c_char);
    set(d, s, to_c_int(data.len()));
}

pub struct EmailQObject {}

#[derive(Clone)]
pub struct EmailEmitter {
    qobject: Arc<Mutex<*const EmailQObject>>,
    body_changed: fn(*const EmailQObject),
    date_changed: fn(*const EmailQObject),
    from_changed: fn(*const EmailQObject),
    html_changed: fn(*const EmailQObject),
    subject_changed: fn(*const EmailQObject),
}

unsafe impl Send for EmailEmitter {}

impl EmailEmitter {
    fn clear(&self) {
        *self.qobject.lock().unwrap() = null();
    }
    pub fn body_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.body_changed)(ptr);
        }
    }
    pub fn date_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.date_changed)(ptr);
        }
    }
    pub fn from_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.from_changed)(ptr);
        }
    }
    pub fn html_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.html_changed)(ptr);
        }
    }
    pub fn subject_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.subject_changed)(ptr);
        }
    }
}

pub trait EmailTrait {
    fn new(emit: EmailEmitter, attachments: Attachments) -> Self;
    fn emit(&self) -> &EmailEmitter;
    fn attachments(&self) -> &Attachments;
    fn attachments_mut(&mut self) -> &mut Attachments;
    fn body<F>(&self, getter: F)
    where
        F: FnOnce(&str);
    fn date<F>(&self, getter: F)
    where
        F: FnOnce(&str);
    fn from<F>(&self, getter: F)
    where
        F: FnOnce(&str);
    fn html<F>(&self, getter: F)
    where
        F: FnOnce(&str);
    fn subject<F>(&self, getter: F)
    where
        F: FnOnce(&str);
}

#[no_mangle]
pub extern "C" fn email_new(
    email: *mut EmailQObject,
    attachments: *mut AttachmentsQObject,
    attachments_new_data_ready: fn(*const AttachmentsQObject),
    attachments_layout_about_to_be_changed: fn(*const AttachmentsQObject),
    attachments_layout_changed: fn(*const AttachmentsQObject),
    attachments_data_changed: fn(*const AttachmentsQObject, usize, usize),
    attachments_begin_reset_model: fn(*const AttachmentsQObject),
    attachments_end_reset_model: fn(*const AttachmentsQObject),
    attachments_begin_insert_rows: fn(*const AttachmentsQObject, usize, usize),
    attachments_end_insert_rows: fn(*const AttachmentsQObject),
    attachments_begin_move_rows: fn(*const AttachmentsQObject, usize, usize, usize),
    attachments_end_move_rows: fn(*const AttachmentsQObject),
    attachments_begin_remove_rows: fn(*const AttachmentsQObject, usize, usize),
    attachments_end_remove_rows: fn(*const AttachmentsQObject),
    email_body_changed: fn(*const EmailQObject),
    email_date_changed: fn(*const EmailQObject),
    email_from_changed: fn(*const EmailQObject),
    email_html_changed: fn(*const EmailQObject),
    email_subject_changed: fn(*const EmailQObject),
) -> *mut Email {
    let attachments_emit = AttachmentsEmitter {
        qobject: Arc::new(Mutex::new(attachments)),
        new_data_ready: attachments_new_data_ready,
    };
    let model = AttachmentsList {
        qobject: attachments,
        layout_about_to_be_changed: attachments_layout_about_to_be_changed,
        layout_changed: attachments_layout_changed,
        data_changed: attachments_data_changed,
        begin_reset_model: attachments_begin_reset_model,
        end_reset_model: attachments_end_reset_model,
        begin_insert_rows: attachments_begin_insert_rows,
        end_insert_rows: attachments_end_insert_rows,
        begin_move_rows: attachments_begin_move_rows,
        end_move_rows: attachments_end_move_rows,
        begin_remove_rows: attachments_begin_remove_rows,
        end_remove_rows: attachments_end_remove_rows,
    };
    let d_attachments = Attachments::new(attachments_emit, model);
    let email_emit = EmailEmitter {
        qobject: Arc::new(Mutex::new(email)),
        body_changed: email_body_changed,
        date_changed: email_date_changed,
        from_changed: email_from_changed,
        html_changed: email_html_changed,
        subject_changed: email_subject_changed,
    };
    let d_email = Email::new(email_emit, d_attachments);
    Box::into_raw(Box::new(d_email))
}

#[no_mangle]
pub unsafe extern "C" fn email_free(ptr: *mut Email) {
    Box::from_raw(ptr).emit().clear();
}

#[no_mangle]
pub unsafe extern "C" fn email_attachments_get(ptr: *mut Email) -> *mut Attachments {
    (&mut *ptr).attachments_mut()
}

#[no_mangle]
pub unsafe extern "C" fn email_body_get(
    ptr: *const Email,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    o.body(|v| {
        let s: *const c_char = v.as_ptr() as (*const c_char);
        set(p, s, to_c_int(v.len()));
    });
}

#[no_mangle]
pub unsafe extern "C" fn email_date_get(
    ptr: *const Email,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    o.date(|v| {
        let s: *const c_char = v.as_ptr() as (*const c_char);
        set(p, s, to_c_int(v.len()));
    });
}

#[no_mangle]
pub unsafe extern "C" fn email_from_get(
    ptr: *const Email,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    o.from(|v| {
        let s: *const c_char = v.as_ptr() as (*const c_char);
        set(p, s, to_c_int(v.len()));
    });
}

#[no_mangle]
pub unsafe extern "C" fn email_html_get(
    ptr: *const Email,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    o.html(|v| {
        let s: *const c_char = v.as_ptr() as (*const c_char);
        set(p, s, to_c_int(v.len()));
    });
}

#[no_mangle]
pub unsafe extern "C" fn email_subject_get(
    ptr: *const Email,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    o.subject(|v| {
        let s: *const c_char = v.as_ptr() as (*const c_char);
        set(p, s, to_c_int(v.len()));
    });
}

pub struct FolderTreeListingQObject {}

#[derive(Clone)]
pub struct FolderTreeListingEmitter {
    qobject: Arc<Mutex<*const FolderTreeListingQObject>>,
    new_data_ready: fn(*const FolderTreeListingQObject, index: COption<usize>),
}

unsafe impl Send for FolderTreeListingEmitter {}

impl FolderTreeListingEmitter {
    fn clear(&self) {
        *self.qobject.lock().unwrap() = null();
    }
    pub fn new_data_ready(&self, item: Option<usize>) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.new_data_ready)(ptr, item.into());
        }
    }
}

#[derive(Clone)]
pub struct FolderTreeListingTree {
    qobject: *const FolderTreeListingQObject,
    layout_about_to_be_changed: fn(*const FolderTreeListingQObject),
    layout_changed: fn(*const FolderTreeListingQObject),
    data_changed: fn(*const FolderTreeListingQObject, usize, usize),
    begin_reset_model: fn(*const FolderTreeListingQObject),
    end_reset_model: fn(*const FolderTreeListingQObject),
    begin_insert_rows: fn(*const FolderTreeListingQObject, index: COption<usize>, usize, usize),
    end_insert_rows: fn(*const FolderTreeListingQObject),
    begin_move_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
        dest: COption<usize>,
        usize,
    ),
    end_move_rows: fn(*const FolderTreeListingQObject),
    begin_remove_rows: fn(*const FolderTreeListingQObject, index: COption<usize>, usize, usize),
    end_remove_rows: fn(*const FolderTreeListingQObject),
}

impl FolderTreeListingTree {
    pub fn layout_about_to_be_changed(&self) {
        (self.layout_about_to_be_changed)(self.qobject);
    }
    pub fn layout_changed(&self) {
        (self.layout_changed)(self.qobject);
    }
    pub fn data_changed(&self, first: usize, last: usize) {
        (self.data_changed)(self.qobject, first, last);
    }
    pub fn begin_reset_model(&self) {
        (self.begin_reset_model)(self.qobject);
    }
    pub fn end_reset_model(&self) {
        (self.end_reset_model)(self.qobject);
    }
    pub fn begin_insert_rows(&self, index: Option<usize>, first: usize, last: usize) {
        (self.begin_insert_rows)(self.qobject, index.into(), first, last);
    }
    pub fn end_insert_rows(&self) {
        (self.end_insert_rows)(self.qobject);
    }
    pub fn begin_move_rows(
        &self,
        index: Option<usize>,
        first: usize,
        last: usize,
        dest: Option<usize>,
        destination: usize,
    ) {
        (self.begin_move_rows)(
            self.qobject,
            index.into(),
            first,
            last,
            dest.into(),
            destination,
        );
    }
    pub fn end_move_rows(&self) {
        (self.end_move_rows)(self.qobject);
    }
    pub fn begin_remove_rows(&self, index: Option<usize>, first: usize, last: usize) {
        (self.begin_remove_rows)(self.qobject, index.into(), first, last);
    }
    pub fn end_remove_rows(&self) {
        (self.end_remove_rows)(self.qobject);
    }
}

pub trait FolderTreeListingTrait {
    fn new(emit: FolderTreeListingEmitter, model: FolderTreeListingTree) -> Self;
    fn emit(&self) -> &FolderTreeListingEmitter;
    fn set_filter(&mut self, filter: String) -> ();
    fn row_count(&self, Option<usize>) -> usize;
    fn can_fetch_more(&self, Option<usize>) -> bool {
        false
    }
    fn fetch_more(&mut self, Option<usize>) {}
    fn sort(&mut self, u8, SortOrder) {}
    fn check_row(&self, index: usize, row: usize) -> Option<usize>;
    fn index(&self, item: Option<usize>, row: usize) -> usize;
    fn parent(&self, index: usize) -> Option<usize>;
    fn row(&self, index: usize) -> usize;
    fn date(&self, index: usize) -> Option<String>;
    fn from(&self, index: usize) -> Option<&str>;
    fn section(&self, index: usize) -> String;
    fn seen(&self, index: usize) -> bool;
    fn subject(&self, index: usize) -> Option<&str>;
    fn uid(&self, index: usize) -> u64;
}

#[no_mangle]
pub extern "C" fn folder_tree_listing_new(
    folder_tree_listing: *mut FolderTreeListingQObject,
    folder_tree_listing_new_data_ready: fn(*const FolderTreeListingQObject, index: COption<usize>),
    folder_tree_listing_layout_about_to_be_changed: fn(*const FolderTreeListingQObject),
    folder_tree_listing_layout_changed: fn(*const FolderTreeListingQObject),
    folder_tree_listing_data_changed: fn(*const FolderTreeListingQObject, usize, usize),
    folder_tree_listing_begin_reset_model: fn(*const FolderTreeListingQObject),
    folder_tree_listing_end_reset_model: fn(*const FolderTreeListingQObject),
    folder_tree_listing_begin_insert_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
    ),
    folder_tree_listing_end_insert_rows: fn(*const FolderTreeListingQObject),
    folder_tree_listing_begin_move_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
        index: COption<usize>,
        usize,
    ),
    folder_tree_listing_end_move_rows: fn(*const FolderTreeListingQObject),
    folder_tree_listing_begin_remove_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
    ),
    folder_tree_listing_end_remove_rows: fn(*const FolderTreeListingQObject),
) -> *mut FolderTreeListing {
    let folder_tree_listing_emit = FolderTreeListingEmitter {
        qobject: Arc::new(Mutex::new(folder_tree_listing)),
        new_data_ready: folder_tree_listing_new_data_ready,
    };
    let model = FolderTreeListingTree {
        qobject: folder_tree_listing,
        layout_about_to_be_changed: folder_tree_listing_layout_about_to_be_changed,
        layout_changed: folder_tree_listing_layout_changed,
        data_changed: folder_tree_listing_data_changed,
        begin_reset_model: folder_tree_listing_begin_reset_model,
        end_reset_model: folder_tree_listing_end_reset_model,
        begin_insert_rows: folder_tree_listing_begin_insert_rows,
        end_insert_rows: folder_tree_listing_end_insert_rows,
        begin_move_rows: folder_tree_listing_begin_move_rows,
        end_move_rows: folder_tree_listing_end_move_rows,
        begin_remove_rows: folder_tree_listing_begin_remove_rows,
        end_remove_rows: folder_tree_listing_end_remove_rows,
    };
    let d_folder_tree_listing = FolderTreeListing::new(folder_tree_listing_emit, model);
    Box::into_raw(Box::new(d_folder_tree_listing))
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_free(ptr: *mut FolderTreeListing) {
    Box::from_raw(ptr).emit().clear();
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_set_filter(
    ptr: *mut FolderTreeListing,
    filter_str: *const c_ushort,
    filter_len: c_int,
) -> () {
    let mut filter = String::new();
    set_string_from_utf16(&mut filter, filter_str, filter_len);
    let o = &mut *ptr;
    let r = o.set_filter(filter);
    r
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_row_count(
    ptr: *const FolderTreeListing,
    index: COption<usize>,
) -> c_int {
    to_c_int((&*ptr).row_count(index.into()))
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_can_fetch_more(
    ptr: *const FolderTreeListing,
    index: COption<usize>,
) -> bool {
    (&*ptr).can_fetch_more(index.into())
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_fetch_more(
    ptr: *mut FolderTreeListing,
    index: COption<usize>,
) {
    (&mut *ptr).fetch_more(index.into())
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_sort(
    ptr: *mut FolderTreeListing,
    column: u8,
    order: SortOrder,
) {
    (&mut *ptr).sort(column, order)
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_check_row(
    ptr: *const FolderTreeListing,
    index: usize,
    row: c_int,
) -> COption<usize> {
    (&*ptr).check_row(index.into(), to_usize(row)).into()
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_index(
    ptr: *const FolderTreeListing,
    index: COption<usize>,
    row: c_int,
) -> usize {
    (&*ptr).index(index.into(), to_usize(row))
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_parent(
    ptr: *const FolderTreeListing,
    index: usize,
) -> QModelIndex {
    if let Some(parent) = (&*ptr).parent(index) {
        QModelIndex {
            row: to_c_int((&*ptr).row(parent)),
            internal_id: parent,
        }
    } else {
        QModelIndex {
            row: -1,
            internal_id: 0,
        }
    }
}
#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_row(
    ptr: *const FolderTreeListing,
    index: usize,
) -> c_int {
    to_c_int((&*ptr).row(index))
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_data_date(
    ptr: *const FolderTreeListing,
    index: usize,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.date(index);
    if let Some(data) = data {
        let s: *const c_char = data.as_ptr() as (*const c_char);
        set(d, s, to_c_int(data.len()));
    }
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_data_from(
    ptr: *const FolderTreeListing,
    index: usize,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.from(index);
    if let Some(data) = data {
        let s: *const c_char = data.as_ptr() as (*const c_char);
        set(d, s, to_c_int(data.len()));
    }
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_data_section(
    ptr: *const FolderTreeListing,
    index: usize,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.section(index);
    let s: *const c_char = data.as_ptr() as (*const c_char);
    set(d, s, to_c_int(data.len()));
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_data_seen(
    ptr: *const FolderTreeListing,
    index: usize,
) -> bool {
    let o = &*ptr;
    o.seen(index).into()
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_data_subject(
    ptr: *const FolderTreeListing,
    index: usize,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.subject(index);
    if let Some(data) = data {
        let s: *const c_char = data.as_ptr() as (*const c_char);
        set(d, s, to_c_int(data.len()));
    }
}

#[no_mangle]
pub unsafe extern "C" fn folder_tree_listing_data_uid(
    ptr: *const FolderTreeListing,
    index: usize,
) -> u64 {
    let o = &*ptr;
    o.uid(index).into()
}

pub struct MailFoldersQObject {}

#[derive(Clone)]
pub struct MailFoldersEmitter {
    qobject: Arc<Mutex<*const MailFoldersQObject>>,
    new_data_ready: fn(*const MailFoldersQObject, index: COption<usize>),
}

unsafe impl Send for MailFoldersEmitter {}

impl MailFoldersEmitter {
    fn clear(&self) {
        *self.qobject.lock().unwrap() = null();
    }
    pub fn new_data_ready(&self, item: Option<usize>) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.new_data_ready)(ptr, item.into());
        }
    }
}

#[derive(Clone)]
pub struct MailFoldersTree {
    qobject: *const MailFoldersQObject,
    layout_about_to_be_changed: fn(*const MailFoldersQObject),
    layout_changed: fn(*const MailFoldersQObject),
    data_changed: fn(*const MailFoldersQObject, usize, usize),
    begin_reset_model: fn(*const MailFoldersQObject),
    end_reset_model: fn(*const MailFoldersQObject),
    begin_insert_rows: fn(*const MailFoldersQObject, index: COption<usize>, usize, usize),
    end_insert_rows: fn(*const MailFoldersQObject),
    begin_move_rows: fn(
        *const MailFoldersQObject,
        index: COption<usize>,
        usize,
        usize,
        dest: COption<usize>,
        usize,
    ),
    end_move_rows: fn(*const MailFoldersQObject),
    begin_remove_rows: fn(*const MailFoldersQObject, index: COption<usize>, usize, usize),
    end_remove_rows: fn(*const MailFoldersQObject),
}

impl MailFoldersTree {
    pub fn layout_about_to_be_changed(&self) {
        (self.layout_about_to_be_changed)(self.qobject);
    }
    pub fn layout_changed(&self) {
        (self.layout_changed)(self.qobject);
    }
    pub fn data_changed(&self, first: usize, last: usize) {
        (self.data_changed)(self.qobject, first, last);
    }
    pub fn begin_reset_model(&self) {
        (self.begin_reset_model)(self.qobject);
    }
    pub fn end_reset_model(&self) {
        (self.end_reset_model)(self.qobject);
    }
    pub fn begin_insert_rows(&self, index: Option<usize>, first: usize, last: usize) {
        (self.begin_insert_rows)(self.qobject, index.into(), first, last);
    }
    pub fn end_insert_rows(&self) {
        (self.end_insert_rows)(self.qobject);
    }
    pub fn begin_move_rows(
        &self,
        index: Option<usize>,
        first: usize,
        last: usize,
        dest: Option<usize>,
        destination: usize,
    ) {
        (self.begin_move_rows)(
            self.qobject,
            index.into(),
            first,
            last,
            dest.into(),
            destination,
        );
    }
    pub fn end_move_rows(&self) {
        (self.end_move_rows)(self.qobject);
    }
    pub fn begin_remove_rows(&self, index: Option<usize>, first: usize, last: usize) {
        (self.begin_remove_rows)(self.qobject, index.into(), first, last);
    }
    pub fn end_remove_rows(&self) {
        (self.end_remove_rows)(self.qobject);
    }
}

pub trait MailFoldersTrait {
    fn new(emit: MailFoldersEmitter, model: MailFoldersTree) -> Self;
    fn emit(&self) -> &MailFoldersEmitter;
    fn row_count(&self, Option<usize>) -> usize;
    fn can_fetch_more(&self, Option<usize>) -> bool {
        false
    }
    fn fetch_more(&mut self, Option<usize>) {}
    fn sort(&mut self, u8, SortOrder) {}
    fn check_row(&self, index: usize, row: usize) -> Option<usize>;
    fn index(&self, item: Option<usize>, row: usize) -> usize;
    fn parent(&self, index: usize) -> Option<usize>;
    fn row(&self, index: usize) -> usize;
    fn delimiter(&self, index: usize) -> &str;
    fn name(&self, index: usize) -> &str;
}

#[no_mangle]
pub extern "C" fn mail_folders_new(
    mail_folders: *mut MailFoldersQObject,
    mail_folders_new_data_ready: fn(*const MailFoldersQObject, index: COption<usize>),
    mail_folders_layout_about_to_be_changed: fn(*const MailFoldersQObject),
    mail_folders_layout_changed: fn(*const MailFoldersQObject),
    mail_folders_data_changed: fn(*const MailFoldersQObject, usize, usize),
    mail_folders_begin_reset_model: fn(*const MailFoldersQObject),
    mail_folders_end_reset_model: fn(*const MailFoldersQObject),
    mail_folders_begin_insert_rows: fn(
        *const MailFoldersQObject,
        index: COption<usize>,
        usize,
        usize,
    ),
    mail_folders_end_insert_rows: fn(*const MailFoldersQObject),
    mail_folders_begin_move_rows: fn(
        *const MailFoldersQObject,
        index: COption<usize>,
        usize,
        usize,
        index: COption<usize>,
        usize,
    ),
    mail_folders_end_move_rows: fn(*const MailFoldersQObject),
    mail_folders_begin_remove_rows: fn(
        *const MailFoldersQObject,
        index: COption<usize>,
        usize,
        usize,
    ),
    mail_folders_end_remove_rows: fn(*const MailFoldersQObject),
) -> *mut MailFolders {
    let mail_folders_emit = MailFoldersEmitter {
        qobject: Arc::new(Mutex::new(mail_folders)),
        new_data_ready: mail_folders_new_data_ready,
    };
    let model = MailFoldersTree {
        qobject: mail_folders,
        layout_about_to_be_changed: mail_folders_layout_about_to_be_changed,
        layout_changed: mail_folders_layout_changed,
        data_changed: mail_folders_data_changed,
        begin_reset_model: mail_folders_begin_reset_model,
        end_reset_model: mail_folders_end_reset_model,
        begin_insert_rows: mail_folders_begin_insert_rows,
        end_insert_rows: mail_folders_end_insert_rows,
        begin_move_rows: mail_folders_begin_move_rows,
        end_move_rows: mail_folders_end_move_rows,
        begin_remove_rows: mail_folders_begin_remove_rows,
        end_remove_rows: mail_folders_end_remove_rows,
    };
    let d_mail_folders = MailFolders::new(mail_folders_emit, model);
    Box::into_raw(Box::new(d_mail_folders))
}

#[no_mangle]
pub unsafe extern "C" fn mail_folders_free(ptr: *mut MailFolders) {
    Box::from_raw(ptr).emit().clear();
}

#[no_mangle]
pub unsafe extern "C" fn mail_folders_row_count(
    ptr: *const MailFolders,
    index: COption<usize>,
) -> c_int {
    to_c_int((&*ptr).row_count(index.into()))
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_can_fetch_more(
    ptr: *const MailFolders,
    index: COption<usize>,
) -> bool {
    (&*ptr).can_fetch_more(index.into())
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_fetch_more(ptr: *mut MailFolders, index: COption<usize>) {
    (&mut *ptr).fetch_more(index.into())
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_sort(ptr: *mut MailFolders, column: u8, order: SortOrder) {
    (&mut *ptr).sort(column, order)
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_check_row(
    ptr: *const MailFolders,
    index: usize,
    row: c_int,
) -> COption<usize> {
    (&*ptr).check_row(index.into(), to_usize(row)).into()
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_index(
    ptr: *const MailFolders,
    index: COption<usize>,
    row: c_int,
) -> usize {
    (&*ptr).index(index.into(), to_usize(row))
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_parent(ptr: *const MailFolders, index: usize) -> QModelIndex {
    if let Some(parent) = (&*ptr).parent(index) {
        QModelIndex {
            row: to_c_int((&*ptr).row(parent)),
            internal_id: parent,
        }
    } else {
        QModelIndex {
            row: -1,
            internal_id: 0,
        }
    }
}
#[no_mangle]
pub unsafe extern "C" fn mail_folders_row(ptr: *const MailFolders, index: usize) -> c_int {
    to_c_int((&*ptr).row(index))
}

#[no_mangle]
pub unsafe extern "C" fn mail_folders_data_delimiter(
    ptr: *const MailFolders,
    index: usize,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.delimiter(index);
    let s: *const c_char = data.as_ptr() as (*const c_char);
    set(d, s, to_c_int(data.len()));
}

#[no_mangle]
pub unsafe extern "C" fn mail_folders_data_name(
    ptr: *const MailFolders,
    index: usize,
    d: *mut QString,
    set: fn(*mut QString, *const c_char, len: c_int),
) {
    let o = &*ptr;
    let data = o.name(index);
    let s: *const c_char = data.as_ptr() as (*const c_char);
    set(d, s, to_c_int(data.len()));
}

pub struct MailModelQObject {}

#[derive(Clone)]
pub struct MailModelEmitter {
    qobject: Arc<Mutex<*const MailModelQObject>>,
    config_file_changed: fn(*const MailModelQObject),
    current_folder_changed: fn(*const MailModelQObject),
}

unsafe impl Send for MailModelEmitter {}

impl MailModelEmitter {
    fn clear(&self) {
        *self.qobject.lock().unwrap() = null();
    }
    pub fn config_file_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.config_file_changed)(ptr);
        }
    }
    pub fn current_folder_changed(&self) {
        let ptr = *self.qobject.lock().unwrap();
        if !ptr.is_null() {
            (self.current_folder_changed)(ptr);
        }
    }
}

pub trait MailModelTrait {
    fn new(
        emit: MailModelEmitter,
        email: Email,
        folder_threads: FolderTreeListing,
        folders: MailFolders,
    ) -> Self;
    fn emit(&self) -> &MailModelEmitter;
    fn config_file(&self) -> Option<&str>;
    fn set_config_file(&mut self, value: Option<String>);
    fn current_folder(&self) -> &str;
    fn set_current_folder(&mut self, value: String);
    fn email(&self) -> &Email;
    fn email_mut(&mut self) -> &mut Email;
    fn folder_threads(&self) -> &FolderTreeListing;
    fn folder_threads_mut(&mut self) -> &mut FolderTreeListing;
    fn folders(&self) -> &MailFolders;
    fn folders_mut(&mut self) -> &mut MailFolders;
    fn set_email(&mut self, uid: u64) -> ();
}

#[no_mangle]
pub extern "C" fn mail_model_new(
    mail_model: *mut MailModelQObject,
    mail_model_config_file_changed: fn(*const MailModelQObject),
    mail_model_current_folder_changed: fn(*const MailModelQObject),
    email: *mut EmailQObject,
    attachments: *mut AttachmentsQObject,
    attachments_new_data_ready: fn(*const AttachmentsQObject),
    attachments_layout_about_to_be_changed: fn(*const AttachmentsQObject),
    attachments_layout_changed: fn(*const AttachmentsQObject),
    attachments_data_changed: fn(*const AttachmentsQObject, usize, usize),
    attachments_begin_reset_model: fn(*const AttachmentsQObject),
    attachments_end_reset_model: fn(*const AttachmentsQObject),
    attachments_begin_insert_rows: fn(*const AttachmentsQObject, usize, usize),
    attachments_end_insert_rows: fn(*const AttachmentsQObject),
    attachments_begin_move_rows: fn(*const AttachmentsQObject, usize, usize, usize),
    attachments_end_move_rows: fn(*const AttachmentsQObject),
    attachments_begin_remove_rows: fn(*const AttachmentsQObject, usize, usize),
    attachments_end_remove_rows: fn(*const AttachmentsQObject),
    email_body_changed: fn(*const EmailQObject),
    email_date_changed: fn(*const EmailQObject),
    email_from_changed: fn(*const EmailQObject),
    email_html_changed: fn(*const EmailQObject),
    email_subject_changed: fn(*const EmailQObject),
    folder_threads: *mut FolderTreeListingQObject,
    folder_threads_new_data_ready: fn(*const FolderTreeListingQObject, index: COption<usize>),
    folder_threads_layout_about_to_be_changed: fn(*const FolderTreeListingQObject),
    folder_threads_layout_changed: fn(*const FolderTreeListingQObject),
    folder_threads_data_changed: fn(*const FolderTreeListingQObject, usize, usize),
    folder_threads_begin_reset_model: fn(*const FolderTreeListingQObject),
    folder_threads_end_reset_model: fn(*const FolderTreeListingQObject),
    folder_threads_begin_insert_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
    ),
    folder_threads_end_insert_rows: fn(*const FolderTreeListingQObject),
    folder_threads_begin_move_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
        index: COption<usize>,
        usize,
    ),
    folder_threads_end_move_rows: fn(*const FolderTreeListingQObject),
    folder_threads_begin_remove_rows: fn(
        *const FolderTreeListingQObject,
        index: COption<usize>,
        usize,
        usize,
    ),
    folder_threads_end_remove_rows: fn(*const FolderTreeListingQObject),
    folders: *mut MailFoldersQObject,
    folders_new_data_ready: fn(*const MailFoldersQObject, index: COption<usize>),
    folders_layout_about_to_be_changed: fn(*const MailFoldersQObject),
    folders_layout_changed: fn(*const MailFoldersQObject),
    folders_data_changed: fn(*const MailFoldersQObject, usize, usize),
    folders_begin_reset_model: fn(*const MailFoldersQObject),
    folders_end_reset_model: fn(*const MailFoldersQObject),
    folders_begin_insert_rows: fn(*const MailFoldersQObject, index: COption<usize>, usize, usize),
    folders_end_insert_rows: fn(*const MailFoldersQObject),
    folders_begin_move_rows: fn(
        *const MailFoldersQObject,
        index: COption<usize>,
        usize,
        usize,
        index: COption<usize>,
        usize,
    ),
    folders_end_move_rows: fn(*const MailFoldersQObject),
    folders_begin_remove_rows: fn(*const MailFoldersQObject, index: COption<usize>, usize, usize),
    folders_end_remove_rows: fn(*const MailFoldersQObject),
) -> *mut MailModel {
    let attachments_emit = AttachmentsEmitter {
        qobject: Arc::new(Mutex::new(attachments)),
        new_data_ready: attachments_new_data_ready,
    };
    let model = AttachmentsList {
        qobject: attachments,
        layout_about_to_be_changed: attachments_layout_about_to_be_changed,
        layout_changed: attachments_layout_changed,
        data_changed: attachments_data_changed,
        begin_reset_model: attachments_begin_reset_model,
        end_reset_model: attachments_end_reset_model,
        begin_insert_rows: attachments_begin_insert_rows,
        end_insert_rows: attachments_end_insert_rows,
        begin_move_rows: attachments_begin_move_rows,
        end_move_rows: attachments_end_move_rows,
        begin_remove_rows: attachments_begin_remove_rows,
        end_remove_rows: attachments_end_remove_rows,
    };
    let d_attachments = Attachments::new(attachments_emit, model);
    let email_emit = EmailEmitter {
        qobject: Arc::new(Mutex::new(email)),
        body_changed: email_body_changed,
        date_changed: email_date_changed,
        from_changed: email_from_changed,
        html_changed: email_html_changed,
        subject_changed: email_subject_changed,
    };
    let d_email = Email::new(email_emit, d_attachments);
    let folder_threads_emit = FolderTreeListingEmitter {
        qobject: Arc::new(Mutex::new(folder_threads)),
        new_data_ready: folder_threads_new_data_ready,
    };
    let model = FolderTreeListingTree {
        qobject: folder_threads,
        layout_about_to_be_changed: folder_threads_layout_about_to_be_changed,
        layout_changed: folder_threads_layout_changed,
        data_changed: folder_threads_data_changed,
        begin_reset_model: folder_threads_begin_reset_model,
        end_reset_model: folder_threads_end_reset_model,
        begin_insert_rows: folder_threads_begin_insert_rows,
        end_insert_rows: folder_threads_end_insert_rows,
        begin_move_rows: folder_threads_begin_move_rows,
        end_move_rows: folder_threads_end_move_rows,
        begin_remove_rows: folder_threads_begin_remove_rows,
        end_remove_rows: folder_threads_end_remove_rows,
    };
    let d_folder_threads = FolderTreeListing::new(folder_threads_emit, model);
    let folders_emit = MailFoldersEmitter {
        qobject: Arc::new(Mutex::new(folders)),
        new_data_ready: folders_new_data_ready,
    };
    let model = MailFoldersTree {
        qobject: folders,
        layout_about_to_be_changed: folders_layout_about_to_be_changed,
        layout_changed: folders_layout_changed,
        data_changed: folders_data_changed,
        begin_reset_model: folders_begin_reset_model,
        end_reset_model: folders_end_reset_model,
        begin_insert_rows: folders_begin_insert_rows,
        end_insert_rows: folders_end_insert_rows,
        begin_move_rows: folders_begin_move_rows,
        end_move_rows: folders_end_move_rows,
        begin_remove_rows: folders_begin_remove_rows,
        end_remove_rows: folders_end_remove_rows,
    };
    let d_folders = MailFolders::new(folders_emit, model);
    let mail_model_emit = MailModelEmitter {
        qobject: Arc::new(Mutex::new(mail_model)),
        config_file_changed: mail_model_config_file_changed,
        current_folder_changed: mail_model_current_folder_changed,
    };
    let d_mail_model = MailModel::new(mail_model_emit, d_email, d_folder_threads, d_folders);
    Box::into_raw(Box::new(d_mail_model))
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_free(ptr: *mut MailModel) {
    Box::from_raw(ptr).emit().clear();
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_config_file_get(
    ptr: *const MailModel,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    let v = o.config_file();
    if let Some(v) = v {
        let s: *const c_char = v.as_ptr() as (*const c_char);
        set(p, s, to_c_int(v.len()));
    }
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_config_file_set(
    ptr: *mut MailModel,
    v: *const c_ushort,
    len: c_int,
) {
    let o = &mut *ptr;
    let mut s = String::new();
    set_string_from_utf16(&mut s, v, len);
    o.set_config_file(Some(s));
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_config_file_set_none(ptr: *mut MailModel) {
    let o = &mut *ptr;
    o.set_config_file(None);
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_current_folder_get(
    ptr: *const MailModel,
    p: *mut QString,
    set: fn(*mut QString, *const c_char, c_int),
) {
    let o = &*ptr;
    let v = o.current_folder();
    let s: *const c_char = v.as_ptr() as (*const c_char);
    set(p, s, to_c_int(v.len()));
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_current_folder_set(
    ptr: *mut MailModel,
    v: *const c_ushort,
    len: c_int,
) {
    let o = &mut *ptr;
    let mut s = String::new();
    set_string_from_utf16(&mut s, v, len);
    o.set_current_folder(s);
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_email_get(ptr: *mut MailModel) -> *mut Email {
    (&mut *ptr).email_mut()
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_folder_threads_get(
    ptr: *mut MailModel,
) -> *mut FolderTreeListing {
    (&mut *ptr).folder_threads_mut()
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_folders_get(ptr: *mut MailModel) -> *mut MailFolders {
    (&mut *ptr).folders_mut()
}

#[no_mangle]
pub unsafe extern "C" fn mail_model_set_email(ptr: *mut MailModel, uid: u64) -> () {
    let o = &mut *ptr;
    let r = o.set_email(uid);
    r
}
